refactorableUsingTemplateMethod <- function() {
  
  potentiallyRefactorableCaseseUsingLambda <- getLambdaRefactorableTable()
  refactorableCaseseUsingLambda <- potentiallyRefactorableCaseseUsingLambda[potentiallyRefactorableCaseseUsingLambda$RefactoringWasOK == "true", ]
  cat(sprintf("Potentially refactorable by lambda: %s, Refactorable: %s\n", nrow(potentiallyRefactorableCaseseUsingLambda), nrow(refactorableCaseseUsingLambda)))
  
  #for (i in 1:length(REFACTORING_TYPES)) {
  #  numberOfCases <- nrow(refactorableCaseseUsingLambda[refactorableCaseseUsingLambda$CloneRefactoringType == (i - 1), ])
  #  cat(sprintf("%2d %s: %d \n", i - 1, REFACTORING_TYPES[i], numberOfCases))
  #}

  potentiallyRefactorableCaseseUsingTemplateMethodJD <- potentiallyRefactorableCaseseUsingLambda[potentiallyRefactorableCaseseUsingLambda$IsTemplateMethodApplicable == "true", ]
  #cat(sprintf("Potentially refactorable by Template Method (JD): %s\n", nrow(potentiallyRefactorableCaseseUsingTemplateMethodJD)))

  refactorableCaseseUsingTemplateMethodByJD <- nrow(potentiallyRefactorableCaseseUsingTemplateMethodJD[potentiallyRefactorableCaseseUsingTemplateMethodJD$RefactoringWasOK == "true", ])
  refactorableUsingTemplateMethodOther = nrow(refactorableCaseseUsingLambda[refactorableCaseseUsingLambda$CloneRefactoringType %in% 4:6, ])
  totalRefactorableWithTemplate <- refactorableCaseseUsingTemplateMethodByJD + refactorableUsingTemplateMethodOther
  percentage <- round(totalRefactorableWithTemplate / nrow(refactorableCaseseUsingLambda), 4) * 100
  cat(sprintf("Refactorable by template method: %s (%s%%)\n", totalRefactorableWithTemplate, percentage))
}

getCloneTypeAndRefactorabilityStats <- function() {
  
  potentiallyRefactorableWithLambda <- getLambdaRefactorableTable()
  #potentiallyRefactorableWithLambda <- potentiallyRefactorableWithLambda[potentiallyRefactorableWithLambda$RefactoringWasOK == "true",]
  
  # Mark clone pairs that have expression diffs
  havingExpressions <- unique(allExpressionGapsInfo[, KEYS])
  havingExpressions$HaveExpressionDiffs <- T
  potentiallyRefactorableWithLambda <- merge(potentiallyRefactorableWithLambda, havingExpressions, by = KEYS, all.x = T)
  potentiallyRefactorableWithLambda$HaveExpressionDiffs[is.na(potentiallyRefactorableWithLambda$HaveExpressionDiffs)] <- F
  
  # Mark clone pairs having blok gaps
  havingBlockGaps <- unique(allBlockGapsInfo[, KEYS])
  havingBlockGaps$HaveBlockGaps <- T
  potentiallyRefactorableWithLambda <- merge(potentiallyRefactorableWithLambda, havingBlockGaps, by = KEYS, all.x = T)
  potentiallyRefactorableWithLambda$HaveBlockGaps[is.na(potentiallyRefactorableWithLambda$HaveBlockGaps)] <- F
  
  onlyHaveExpressionDiffs <- potentiallyRefactorableWithLambda[potentiallyRefactorableWithLambda$HaveExpressionDiffs == T & potentiallyRefactorableWithLambda$HaveBlockGaps == F, ]
  onlyHaveBlockGaps <- potentiallyRefactorableWithLambda[potentiallyRefactorableWithLambda$HaveExpressionDiffs == F & potentiallyRefactorableWithLambda$HaveBlockGaps == T, ]
  haveBoth <- potentiallyRefactorableWithLambda[potentiallyRefactorableWithLambda$HaveExpressionDiffs == T & potentiallyRefactorableWithLambda$HaveBlockGaps == T, ]
  haveNone <- potentiallyRefactorableWithLambda[potentiallyRefactorableWithLambda$HaveExpressionDiffs == F & potentiallyRefactorableWithLambda$HaveBlockGaps == F, ]
  
  typeII <- rbind(onlyHaveExpressionDiffs, haveNone[haveNone$CloneType == 2, ])
  typeIII <- rbind(onlyHaveBlockGaps, haveBoth, haveNone[haveNone$CloneType == 3, ])
  
  print(nrow(haveNone[haveNone$CloneType != 3 & haveNone$CloneType != 2, ]))
  
  refactorableTypeII <- typeII[typeII$RefactoringWasOK == "true", ]
  refactorableTypeIII <- typeIII[typeIII$RefactoringWasOK == "true", ]

  cat(sprintf("Type II: %s (%s%%), Applicable: %s (%s%%)\n Type III: %s (%s%%), Applicable: %s (%s%%)",
      nrow(typeII), nrow(typeII) / nrow(potentiallyRefactorableWithLambda),
      nrow(refactorableTypeII), nrow(refactorableTypeII) / nrow(typeII),
      nrow(typeIII), nrow(typeIII) / nrow(potentiallyRefactorableWithLambda),
      nrow(refactorableTypeIII), nrow(refactorableTypeIII) / nrow(typeIII)
      )
  )
  
}

getRefactorableUsingLambda <- function(table = NULL) {
  
  if (is.null(table)) {
    canPotentiallyBeRefactoredWithLambdaTable <- getLambdaRefactorableTable()
  } else {
    canPotentiallyBeRefactoredWithLambdaTable = table
  }

  canBeRefactoredWithLambdaTable <- canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$RefactoringWasOK == "true", ]
  
  canPotentiallyBeRefactoredWithLambda <- nrow(canPotentiallyBeRefactoredWithLambdaTable)
  canBeRefactoredWithLambda <- nrow(canBeRefactoredWithLambdaTable)
  cat(sprintf("Can be potentially refactored by lambda: %d\nActually refactorable by lambda: %d (%f)\n", 
              canPotentiallyBeRefactoredWithLambda,
              canBeRefactoredWithLambda,
              canBeRefactoredWithLambda / canPotentiallyBeRefactoredWithLambda * 100))
  
  cat(sprintf("Having compile errors: %s\n", 
              nrow(canPotentiallyBeRefactoredWithLambdaTable[ canPotentiallyBeRefactoredWithLambdaTable$HadCompileErrorsAfterRefactoring == "true",])))
  
  cat(sprintf("Having tests failed: %s\n",
              nrow(canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$TestsFailedAfterRefactoring == "true",])))
  
}

getResultsPerProject <- function(F) {
  
  if (is.function(F)) {
    canPotentiallyBeRefactoredWithLambdaTable <- getLambdaRefactorableTable()
    
    swallow <- by(data = canPotentiallyBeRefactoredWithLambdaTable, 
                  INDICES = canPotentiallyBeRefactoredWithLambdaTable$Prj, 
                  FUN = function(potentialThisProject) {
                    cat(sprintf("\nProject: %s\n", unique(potentialThisProject$Prj)))
                    F(potentialThisProject)
                    cat("--------\n")
                  })
  }
}

getRefactorableUsingLambdaPerProject <- function() {
  getResultsPerProject(getRefactorableUsingLambda)
}

getPreconditionsInRefactorableWithLambdas <- function() {
  reportsNtrees <- merge(reportsTreesJoined, allPreconditionViolations, BY = KEYS)
  temp <- reportsNtrees[reportsNtrees$X.PreconditionViolations > 0 & reportsNtrees$RefactoringWasOK == "true",]
  preconds <- unique(temp$PreconditionViolationType)
  for (p in preconds) {
    cat(sprintf("%d: %s\n", p, PRECONDITION_VIOLATION_NAMES[p + 1]))
  }
}

printRefactorableLocation <- function(mode = "") {
  
  canPotentiallyBeRefactoredWithLambdaTable <- getLambdaRefactorableTable()
  
  if (mode == "TEST") {
    canPotentiallyBeRefactoredWithLambdaTable <- canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$IsTestCode == 3, ]
  } else if (mode == "PRODUCTION") {
    canPotentiallyBeRefactoredWithLambdaTable <- canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$IsTestCode != 3, ]
  }
  
  names <- c("Same method", "Same declaring class", "Same java file", "Same hierarchy", "Different classes")

  allPotentiallyRefactorableByLambda <- nrow(canPotentiallyBeRefactoredWithLambdaTable)
  for (i in 0:length(names) - 1) {
    canPotentiallyBeRefactoreableThisCategoryTable <- canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$ClonePairLocation == i, ]
    canPotentiallyBeRefactoreableThisCategory <- nrow(canPotentiallyBeRefactoreableThisCategoryTable)
    canBeRefactoredWithLambdaThisCategoryTable <- 
      canPotentiallyBeRefactoreableThisCategoryTable[canPotentiallyBeRefactoreableThisCategoryTable$RefactoringWasOK == "true", ]
    canBeRefactoredWithLambdaThisCategory <- nrow(canBeRefactoredWithLambdaThisCategoryTable)
    
    cat(sprintf("& %20s & %6s (%4s\\%%) & %6s (%4s\\%%) \\\\\r\n",
                names[i + 1],
                canPotentiallyBeRefactoreableThisCategory, 
                100 * round(canPotentiallyBeRefactoreableThisCategory / allPotentiallyRefactorableByLambda, 3), 
                canBeRefactoredWithLambdaThisCategory,
                100 * round(canBeRefactoredWithLambdaThisCategory / canPotentiallyBeRefactoreableThisCategory, 3)))
  }    
  n <- nrow(canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$RefactoringWasOK == "true", ])
  cat(sprintf("& %20s & \\textbf{%6s (%4s\\%%)} & \\textbf{%6s (%4s\\%%)} \\\\\r\n",
              "\\textbf{Total}",
              nrow(canPotentiallyBeRefactoredWithLambdaTable), 
              100 * round(nrow(canPotentiallyBeRefactoredWithLambdaTable) / allPotentiallyRefactorableByLambda, 3), 
              n,
              100 * round(n / nrow(canPotentiallyBeRefactoredWithLambdaTable), 3)))
}

testVSProduction <- function(table = NULL) {
  
  if (is.null(table)) {
    canPotentiallyBeRefactoredWithLambdaTable <- getLambdaRefactorableTable()
  } else {
    canPotentiallyBeRefactoredWithLambdaTable <- table
  }
  
  canBeRefactoredWithLambdaTable <- canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$RefactoringWasOK == "true",]
  
  prod <- nrow(canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$IsTestCode != 3, ])
  prodRefactorable <- nrow(canBeRefactoredWithLambdaTable[canBeRefactoredWithLambdaTable$IsTestCode != 3, ])
  
  test <- nrow(canPotentiallyBeRefactoredWithLambdaTable[canPotentiallyBeRefactoredWithLambdaTable$IsTestCode == 3, ])
  testRefactorable <- nrow(canBeRefactoredWithLambdaTable[canBeRefactoredWithLambdaTable$IsTestCode == 3, ])
  
  cat(sprintf("Production refactorable: %s out of %s (%s%%), Test refactorable : %s out of %s (%s%%)\n", 
              prodRefactorable, prod,
              100 * round(prodRefactorable / prod, 3), 
              testRefactorable, test,
              100 * round(testRefactorable / test, 3)))
}

testVSProductionPerProject <- function() {
  getResultsPerProject(testVSProduction)
}

testVSProductionVSLocation <- function() {
  printRefactorableLocation()
  cat("\\midrule\n")
  printRefactorableLocation("PRODUCTION")
  cat("\\midrule\n")
  printRefactorableLocation("TEST")
}

getLambdaRefactorableTable <- function() {
  toExclude <- unique(allPreconditionViolations[allPreconditionViolations$PreconditionViolationType %in% c(4:6, 10, 14:21, 24:26), KEYS])
  toExclude$ShouldBeExcluded <- T
  reportsNtrees <- merge(x = reportsTreesJoined, y = toExclude, BY = KEYS, all.x = T)
  reportsNtrees$ShouldBeExcluded[is.na(reportsNtrees$ShouldBeExcluded)] <- F
  #reportsNtrees <- reportsNtrees[reportsNtrees$HadCompileErrorsAfterRefactoring != "true",]
  #reportsNtrees <- reportsNtrees[reportsNtrees$TestsFailedAfterRefactoring != "true",]
  canPotentiallyBeRefactoredWithLambdaTable <- reportsNtrees[reportsNtrees$X.PreconditionViolations > 0 & reportsNtrees$ShouldBeExcluded != T & reportsNtrees$CloneType != 1, ]
  canPotentiallyBeRefactoredWithLambdaTable$Prj <- (gsub(pattern = "_.*", x = canPotentiallyBeRefactoredWithLambdaTable$ProjectName, replacement = ""))
  

  return(canPotentiallyBeRefactoredWithLambdaTable)
}

getLambdaInfo <- function() {
  
  canPotentiallyBeRefactoredWithLambdaTable <- getLambdaRefactorableTable()
  
  blockGapsInfo <- allBlockGapsInfo[, c(KEYS, "X.Params")]
  blockGapsInfo <- merge(blockGapsInfo, canPotentiallyBeRefactoredWithLambdaTable, BY = KEYS)
  blockGapsInfo$Type <- "BlockGap"
  
  expressionGapsInfo <- allExpressionGapsInfo[, c(KEYS, "X.Params")]
  expressionGapsInfo <- merge(expressionGapsInfo, canPotentiallyBeRefactoredWithLambdaTable, BY = KEYS)
  expressionGapsInfo$Type <- "ExpressionGap"
  
  lambdaInfo <- rbind(blockGapsInfo, expressionGapsInfo)
  
  return(lambdaInfo)
}